import { EntityRepository, Repository } from "typeorm";
import { UpdateCareerListPageCmsDto } from "./dto/update-career-list-page-cms.dto";
import { CareerListPageCmsEntity } from "./entities/career-list-page-cms.entity";

@EntityRepository(CareerListPageCmsEntity)
export class CareerListPageCmsRepository extends Repository<CareerListPageCmsEntity> {

  async createEntity(dto: UpdateCareerListPageCmsDto): Promise<CareerListPageCmsEntity | Error> {
    try {
      const entity = this.create({
        jobSectionTitle: dto.jobSectionTitle,
        jobSectionSubTitle: dto.jobSectionSubTitle,
        whyJoinUsSectionTitle: dto.whyJoinUsSectionTitle,
        whyJoinUsSectionSubTitle: dto.whyJoinUsSectionSubTitle
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateCareerListPageCmsDto, id: string): Promise<CareerListPageCmsEntity | Error> {
    try {
      await this.update(id, {
        jobSectionTitle: dto.jobSectionTitle,
        jobSectionSubTitle: dto.jobSectionSubTitle,
        whyJoinUsSectionTitle: dto.whyJoinUsSectionTitle,
        whyJoinUsSectionSubTitle: dto.whyJoinUsSectionSubTitle
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<CareerListPageCmsEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}