import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { HeroSectionLeftCmsDefaultService } from "./hero-section-left-cms-default.service";
import { UpdateHeroSectionLeftCmsDefaultDto } from "./dto/update-hero-section-left-cms-default.dto";

@Controller({ path: "hero-section-left-cms-default", version: Constants.API_VERSION_1 })
export class HeroSectionLeftCmsDefaultController {
  constructor(private readonly service: HeroSectionLeftCmsDefaultService) {
  }

  @Post()
  @HttpCode(HttpStatus.OK)
  @UseGuards(AdminAuthGuard)
  updateOrCreateData(
    @Body() dto: UpdateHeroSectionLeftCmsDefaultDto
  ) {
    return this.service.updateOrCreateData(dto);
  }

  @Get()
  // @UseGuards(AdminAuthGuard)
  findAll() {
    return this.service.findAll();
  }
}
