import { EntityRepository, Repository } from "typeorm";
import { UpdateHeroSectionLeftCmsDefaultDto } from "./dto/update-hero-section-left-cms-default.dto";
import { HeroSectionLeftCmsDefaultEntity } from "./entities/hero-section-left-cms-default.entity";

@EntityRepository(HeroSectionLeftCmsDefaultEntity)
export class HeroSectionLeftCmsDefaultRepository extends Repository<HeroSectionLeftCmsDefaultEntity> {

  async createEntity(dto: UpdateHeroSectionLeftCmsDefaultDto): Promise<HeroSectionLeftCmsDefaultEntity | Error> {
    try {
      const entity = this.create({
        title: dto.title,
        description: dto.description,
        buttonText: dto.buttonText,
        buttonLink: dto.buttonLink
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateHeroSectionLeftCmsDefaultDto, id: string): Promise<HeroSectionLeftCmsDefaultEntity | Error> {
    try {
      await this.update(id, {
        title: dto.title,
        description: dto.description,
        buttonText: dto.buttonText,
        buttonLink: dto.buttonLink
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<HeroSectionLeftCmsDefaultEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}