import { EntityRepository, Repository } from "typeorm";
import { UpdateHeroSectionLeftCmsDto } from "./dto/update-hero-section-left-cms.dto";
import { HeroSectionLeftCmsEntity } from "./entities/hero-section-left-cms.entity";

@EntityRepository(HeroSectionLeftCmsEntity)
export class HeroSectionLeftCmsRepository extends Repository<HeroSectionLeftCmsEntity> {

  async createEntity(dto: UpdateHeroSectionLeftCmsDto): Promise<HeroSectionLeftCmsEntity | Error> {
    try {
      const entity = this.create({
        retailerId: dto.retailerId,
        retailerName: dto.retailerName,
        title: dto.title,
        description: dto.description,
        buttonText: dto.buttonText,
        buttonLink: dto.buttonLink
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateHeroSectionLeftCmsDto, id: string): Promise<HeroSectionLeftCmsEntity | Error> {
    try {
      await this.update(id, {
        retailerName: dto.retailerName,
        title: dto.title,
        description: dto.description,
        buttonText: dto.buttonText,
        buttonLink: dto.buttonLink
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<HeroSectionLeftCmsEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}