import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { UpdatePageMetaCmsDto } from "./dto/update-page-meta-cms.dto";
import { PageMetaCmsService } from "./page-meta-cms.service";

@Controller({ path: "page-meta-cms", version: Constants.API_VERSION_1 })

export class PageMetaCmsController {
  constructor(private readonly service: PageMetaCmsService) {
  }

  @Post()
  @HttpCode(HttpStatus.OK)
  @UseGuards(AdminAuthGuard)
  updateOrCreateData(
    @Body() dto: UpdatePageMetaCmsDto
  ) {
    return this.service.updateOrCreateData(dto);
  }

  @Get()
  // @UseGuards(AdminAuthGuard)
  findAll() {
    return this.service.findAll();
  }
}
