import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { UpdatePageTitleCmsDto } from "./dto/update-page-title-cms.dto";
import { PageTitleCmsService } from "./page-title-cms.service";

@Controller({ path: "page-title-cms", version: Constants.API_VERSION_1 })

export class PageTitleCmsController {
  constructor(private readonly service: PageTitleCmsService) {
  }

  @Post()
  @HttpCode(HttpStatus.OK)
  @UseGuards(AdminAuthGuard)
  updateOrCreateData(
    @Body() dto: UpdatePageTitleCmsDto
  ) {
    return this.service.updateOrCreateData(dto);
  }

  @Get()
  // @UseGuards(AdminAuthGuard)
  findAll() {
    return this.service.findAll();
  }
}
