import { EntityRepository, Repository } from "typeorm";
import { UpdateHomePageComponentUiDto } from "./dto/update-home-page-component-ui.dto";
import { HomePageComponentUi } from "./entities/home-page-component-ui.entity";

@EntityRepository(HomePageComponentUi)
export class HomePageComponentUiRepository extends Repository<HomePageComponentUi> {

  async createEntity(dto: UpdateHomePageComponentUiDto): Promise<HomePageComponentUi | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        categorySectionTitleFontColor: dto.categorySectionTitleFontColor,
        flowerSectionTitleFontColor: dto.flowerSectionTitleFontColor,
        dispoDifferenceSectionTitleFontColor: dto.dispoDifferenceSectionTitleFontColor,
        reeferAFriendSectionTitleFontColor: dto.reeferAFriendSectionTitleFontColor,
        instagramSectionTitleFontColor: dto.instagramSectionTitleFontColor,
        categorySectionSubtitleFontColor: dto.categorySectionSubtitleFontColor,
        flowerSectionSubtitleFontColor: dto.flowerSectionSubtitleFontColor,
        dispoDifferenceSectionSubtitleFontColor: dto.dispoDifferenceSectionSubtitleFontColor,
        reeferAFriendSectionSubtitleFontColor: dto.reeferAFriendSectionSubtitleFontColor,
        instagramSectionSubtitleFontColor: dto.instagramSectionSubtitleFontColor,
        footerSectionBackgroundColor: dto.footerSectionBackgroundColor,
        dispoDifferenceSubSectionOneTitleFontColor: dto.dispoDifferenceSubSectionOneTitleFontColor,
        dispoDifferenceSubSectionOneSubtitleFontColor: dto.dispoDifferenceSubSectionOneSubtitleFontColor,
        dispoDifferenceSubSectionTwoTitleFontColor: dto.dispoDifferenceSubSectionTwoTitleFontColor,
        dispoDifferenceSubSectionTwoSubtitleFontColor: dto.dispoDifferenceSubSectionTwoSubtitleFontColor,
        brandSectionTitleFontColor: dto.brandSectionTitleFontColor,
        brandSectionSubtitleFontColor: dto.brandSectionSubtitleFontColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateHomePageComponentUiDto, id: string): Promise<HomePageComponentUi | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        categorySectionTitleFontColor: dto.categorySectionTitleFontColor,
        flowerSectionTitleFontColor: dto.flowerSectionTitleFontColor,
        dispoDifferenceSectionTitleFontColor: dto.dispoDifferenceSectionTitleFontColor,
        reeferAFriendSectionTitleFontColor: dto.reeferAFriendSectionTitleFontColor,
        instagramSectionTitleFontColor: dto.instagramSectionTitleFontColor,
        categorySectionSubtitleFontColor: dto.categorySectionSubtitleFontColor,
        flowerSectionSubtitleFontColor: dto.flowerSectionSubtitleFontColor,
        dispoDifferenceSectionSubtitleFontColor: dto.dispoDifferenceSectionSubtitleFontColor,
        reeferAFriendSectionSubtitleFontColor: dto.reeferAFriendSectionSubtitleFontColor,
        instagramSectionSubtitleFontColor: dto.instagramSectionSubtitleFontColor,
        footerSectionBackgroundColor: dto.footerSectionBackgroundColor,
        dispoDifferenceSubSectionOneTitleFontColor: dto.dispoDifferenceSubSectionOneTitleFontColor,
        dispoDifferenceSubSectionOneSubtitleFontColor: dto.dispoDifferenceSubSectionOneSubtitleFontColor,
        dispoDifferenceSubSectionTwoTitleFontColor: dto.dispoDifferenceSubSectionTwoTitleFontColor,
        dispoDifferenceSubSectionTwoSubtitleFontColor: dto.dispoDifferenceSubSectionTwoSubtitleFontColor,
        brandSectionTitleFontColor: dto.brandSectionTitleFontColor,
        brandSectionSubtitleFontColor: dto.brandSectionSubtitleFontColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<HomePageComponentUi[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}