import { EntityRepository, Repository } from "typeorm";
import { UpdateLandingPageComponentUiDto } from "./dto/update-landing-page-component-ui.dto";
import { LandingPageComponentUiEntity } from "./entities/landing-page-component-ui.entity";

@EntityRepository(LandingPageComponentUiEntity)
export class LandingPageComponentUiRepository extends Repository<LandingPageComponentUiEntity> {

  async createEntity(dto: UpdateLandingPageComponentUiDto): Promise<LandingPageComponentUiEntity | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor,
        fontColor: dto.fontColor,
        checkboxFontColor: dto.checkboxFontColor,
        buttonColor: dto.buttonColor,
        buttonFontColor: dto.buttonFontColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateLandingPageComponentUiDto, id: string): Promise<LandingPageComponentUiEntity | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor,
        fontColor: dto.fontColor,
        checkboxFontColor: dto.checkboxFontColor,
        buttonColor: dto.buttonColor,
        buttonFontColor: dto.buttonFontColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<LandingPageComponentUiEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}