import { EntityRepository, Repository } from "typeorm";
import { UpdateTopTickerComponentUiDto } from "./dto/update-top-ticker-component-ui.dto";
import { TopTickerComponentUiEntity } from "./entities/top-ticker-component-ui.entity";

@EntityRepository(TopTickerComponentUiEntity)
export class TopTickerComponentUiRepository extends Repository<TopTickerComponentUiEntity> {

  async createEntity(dto: UpdateTopTickerComponentUiDto): Promise<TopTickerComponentUiEntity | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        fontColor: dto.fontColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateTopTickerComponentUiDto, id: string): Promise<TopTickerComponentUiEntity | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        fontColor: dto.fontColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<TopTickerComponentUiEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}