import { Module } from "@nestjs/common";
import { JwtModule } from "@nestjs/jwt";
import { TypeOrmModule } from "@nestjs/typeorm";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { DoSpacesServicerovider } from "../SpacesModule/SpacesService";
import { DoSpacesService } from "../SpacesModule/SpacesService/doSpacesService";
import { ContactUsSectionOneDefaultController } from "./contact-us-section-one-default.controller";
import { ContactUsSectionOneDefaultRepository } from "./contact-us-section-one-default.repository";
import { ContactUsSectionOneDefaultService } from "./contact-us-section-one-default.service";

@Module({
  imports: [
    JwtModule.registerAsync({
      useClass: JwtConfigService
    }),
    TypeOrmModule.forFeature([UsersRepository]),
    TypeOrmModule.forFeature([ContactUsSectionOneDefaultRepository])
  ],
  controllers: [ContactUsSectionOneDefaultController],
  providers: [ContactUsSectionOneDefaultService, JwtHelper, DoSpacesService, DoSpacesServicerovider]
})
export class ContactUsSectionOneDefaultModule {
}
