import { EntityRepository, getConnection, Repository } from "typeorm";
import { ProductBrandEntity } from "./entities/product-brand.entity";

@EntityRepository(ProductBrandEntity)
export class ProductBrandRepository extends Repository<ProductBrandEntity> {
  async findByFilterQuery(query: any): Promise<any | Error> {
    try {
      return await this.find({
        where: { ...query, isDeleted: false }
      });
    } catch (e) {
      return e;
    }
  }

  async createEntities(dtos: any): Promise<any | Error> {
    await getConnection()
      .createQueryBuilder()
      .insert()
      .into(ProductBrandEntity)
      .values(dtos)
      .execute();
  }

  async deleteRowsFromDatabase(productIds: any): Promise<boolean> {
    const updateResult = await getConnection()
      .createQueryBuilder()
      .delete()
      .from(ProductBrandEntity)
      .where("productId IN (:...ids)", { ids: productIds })
      .execute();

    return updateResult.affected > 0;
  }
}