import { Body, Controller, Post } from "@nestjs/common";
import { MailSenderService } from "./mail-sender.service";
import { CreateMailSenderDto } from "./dto/create-mail-sender.dto";
import { Constants } from "../../utils/constants";

@Controller({
  path: "mail-sender",
  version: Constants.API_VERSION_1
})
export class MailSenderController {
  constructor(private readonly mailSenderService: MailSenderService) {
  }

  @Post("/send")
  async send(@Body() dto: CreateMailSenderDto) {
    console.log(dto);
    return await this.mailSenderService.send(dto);
  }
}
